<?php
/*
Plugin Name: Phish.net for Wordpress
Plugin URI: http://api.phish.net/wordpress/
Description: Creates a shortcode to embed a Phish.net setlist into a Wordpress post or page.  To use this plugin, add this shortcode to your post [phishnet date="YYYY-MM-DD" apikey="123456"] If there are multiple shows on that date, it will default to the first phish show.  Also, this plugin creates sidebar widgets that allows you to embed upcoming shows and/or the most recent setlist. 
Author: Adam Scheinberg
Version: 1.0β
Author URI: http://www.firsttube.com
Last Modification: 27 Sep 2012
Usage:  [phishnet date="YYYY-MM-DD" apikey="123456"] 
*/

/* -- slugify() creates URL safe slugs ---------------------------------------------------------------------------- */ 
if(!function_exists('slugify')) {
	function slugify($str) { 
		$str = preg_replace('/[^a-zA-Z0-9 -]/', '', $str);
		$str = strtolower(str_replace(' ', '-', trim($str)));
		$str = preg_replace('/-+/', '-', $str);
		return $str; 	
	}
}

/* -- cot short code plugin  ---------------------------------------------------------------------------- */ 
/* 	We've got to enqueue this here to show in the header and actually echo the code. 
	Otherwise, it will echo in the footer and the output won't show. 
	Need a better solution for this in the next release via a new hosted callback.  
*/ 
wp_enqueue_script('phishnetsetlistcallback','http://api.phish.net/callbacks/pnet3-setlist.js'); 

function phishnet_shortcode($atts) {
     extract(shortcode_atts(array('date'=>'', 'apikey'=>''), $atts));
     if(''==$apikey) { return; }
     $cleandate = @date("Y-m-d",@strtotime($date)); 
     if(date("Y",strtotime($cleandate)) == 1969) { $method='pnet.shows.setlists.latest'; } else { $method='pnet.shows.setlists.get'; }  
     return '<script src="https://api.phish.net/api.js?api=2.0&method='.$method.'&format=json&apikey='.$apikey
     .'&callback=pnet3setlist&showdate='.$cleandate.'"></script>
     ';      
}
add_shortcode('phishnet', 'phishnet_shortcode');

/* -- Phish.net stylesheet ---------------------------------------------------------------------------- */ 
//add_action('wp_enqueue_scripts','phishnet_stylesheet');

//function cot_stylesheet() {
//	wp_register_style('phishnet-style', plugins_url('style.css', __FILE__) );
//	wp_enqueue_style('phishnet-style');
//}

/* -- API requester ---------------------------------------------------------------------------- */ 
function phishnet_api_req($data) { 
	$ch = curl_init('https://api.phish.net/api.js');
	curl_setopt($ch, CURLOPT_POST,true);
	if(is_array($data)) { $data = http_build_query($data); } 
	curl_setopt($ch, CURLOPT_POSTFIELDS,$data);
	curl_setopt($ch, CURLOPT_FOLLOWLOCATION,1);
	curl_setopt($ch, CURLOPT_HEADER,0);  // DO NOT RETURN HTTP HEADERS
	curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);  // RETURN THE CONTENTS OF THE CALL
	return curl_exec($ch);
}

/* -- Caching ---------------------------------------------------------------------------- */ 
define( 'PHISHNET_PLUGIN_PATH', plugin_dir_path(__FILE__) );
 

function phishnet_is_cache_expired($page,$cacheseconds=3600) { 
	if(@filemtime($page)<time()-$cacheseconds) { return false; } 
	return true; 
}

function phishnet_putcache($page,$json) {
	file_put_contents($page,$json);
	return true; 
}
	
function phishnet_getcache($page) {
	return file_get_contents($page);
}

include PHISHNET_PLUGIN_PATH.'widget_upcoming.php';
include PHISHNET_PLUGIN_PATH.'widget_latest.php';
include PHISHNET_PLUGIN_PATH.'widget_random.php';
include PHISHNET_PLUGIN_PATH.'widget_tiph.php';