<?php

/* -- Phish.net upcoming shows widget ---------------------------------------------------------------------------- */ 
class phishnet_latest_Widget extends WP_Widget {

	public function __construct() {
		parent::__construct(
	 		'phishnet_latest_Widget', // Base ID
			'Phish.net Latest', // Name
			array( 'description' => __( 'Latest Show on Phish.net', 'text_domain' ), ) // Args
		);
	}


	public function widget( $args, $instance ) {
		$thiscache = plugin_dir_path(__FILE__).'cache/latest.json';
		extract( $args );
		$title = apply_filters( 'widget_title', $instance['title'] );
		if(phishnet_is_cache_expired($thiscache,10)) { //if it's cached and not stale, get it 
			$json = phishnet_getcache($thiscache); 
		} else { 
			$json = phishnet_api_req(array('method'=>'pnet.shows.setlists.latest', 'api'=>'2.0')); //get data from API 
			phishnet_putcache($thiscache,$json); //cache json 
		}
		$arr = @json_decode($json,1); 
		if(!is_array($arr)) { return; }
		echo $before_widget;
		if ( empty( $title ) ) { $title='Latest Show on Phish.net'; }
		echo $before_title . $title . $after_title;
		echo "<div id=\"pnetsetlist\">";
		for($i=0;$i<sizeof($arr);$i++) {
			$n = $arr[$i];
			echo "<h3>".$n['mmddyy']." <a href=\"http://phish.net/setlists/?d=".$n['showdate']."\">".$n['venue']."</a></h3>
			<p class='pnetsl'>".$n['setlistdata']."</p>";
			if(trim($n['setlistnotes'])!='') { echo "<p class='pnetsn' style=\"font-size:small\">".$n['setlistnotes']."</p>"; }
		}
		echo "</div>
		<p>For more setlists, visit <img src=\"http://media.phish.net/minipnet.png\" alt=\"Phish.net\" />
		<a href=\"http://phish.net\">Phish.net</a></p>";
		echo $after_widget;
	}

	public function update( $new_instance, $old_instance ) {
		$instance = array();
		$instance['title'] = strip_tags( $new_instance['title'] );
		return $instance;
	}

	public function form( $instance ) {
		if ( isset( $instance[ 'title' ] ) ) { $title = $instance[ 'title' ]; } else { $title = __( 'Latest Show on Phish.net', 'text_domain' ); }
		?>
		<p>
		<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:' ); ?></label> 
		<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
		</p>
		<?php 
	}

} // Widget

// register widget
add_action( 'widgets_init', create_function( '', 'register_widget( "phishnet_latest_Widget" );' ) );