<?php

/* -- Phish.net upcoming shows widget ---------------------------------------------------------------------------- */ 
class phishnet_upcoming_Widget extends WP_Widget {

	public function __construct() {
		parent::__construct(
	 		'phishnet_upcoming_Widget', // Base ID
			'Phish.net Upcoming', // Name
			array( 'description' => __( 'Upcoming Shows from Phish.net', 'text_domain' ), ) // Args
		);
	}


	public function widget( $args, $instance ) {
		$thiscache = plugin_dir_path(__FILE__).'cache/upcoming.json';
		extract( $args );
		$title = apply_filters( 'widget_title', $instance['title'] );
		$numshows = $instance['numshows'];
		if(phishnet_is_cache_expired($thiscache,3600)) { //if it's cached and not stale, get it 
			$json = phishnet_getcache($thiscache); 
		} else { 
			$json = phishnet_api_req(array('method'=>'pnet.shows.upcoming', 'api'=>'2.0')); //get data from API 
			phishnet_putcache($thiscache,$json); //cache json 
		}
		$arr = @json_decode($json,1); 
		if(!is_array($arr)) { return; }
		echo $before_widget;
		if ( empty( $title ) ) { $title='Upcoming Shows from Phish.net'; }
		echo $before_title . $title . $after_title;
		if(is_array($arr)) { 
			echo "<ul>"; $i=0; 
			foreach($arr as $k=>$v) { 
				if($i<$numshows) {
					$v = array_map('stripslashes',$v); 
					echo "<li><b><a href=\"".$v['link']."\">",$v['showdate'],"</a></b>, <a href=\"".$v['artisturl']."\">"
					. $v['artist']."</a> at <em>".$v['venuename']."</em></li>";
					$i++; 
				}
			} 		
			echo "</ul>
			<p>For more setlists, visit <img src=\"http://media.phish.net/minipnet.png\" alt=\"Phish.net\" />
			<a href=\"http://phish.net\">Phish.net</a></p>";
		}
		echo $after_widget;
	}

	public function update( $new_instance, $old_instance ) {
		$instance = array();
		$instance['title'] = strip_tags( $new_instance['title'] );
		$instance['numshows'] = (int) $new_instance['numshows'];
		return $instance;
	}

	public function form( $instance ) {
		if ( isset( $instance[ 'title' ] ) ) { $title = $instance[ 'title' ]; } else { $title = __( 'Upcoming Shows from Phish.net', 'text_domain' ); }
		if($instance['numshows']<1 || $instance['numshows']>20) { $instance['numshows']=20; }
		?>
		<p>
		<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:' ); ?></label> 
		<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
		</p>
		<p>
		<label for="<?php echo $this->get_field_id( 'numshows' ); ?>"><?php _e( 'Max Number of Shows:' ); ?></label> 
		<input class="widefat" id="<?php echo $this->get_field_id( 'numshows' ); ?>" name="<?php echo $this->get_field_name( 'numshows' ); ?>" type="text" value="<?php echo intval($instance['numshows']); ?>" />
		</p>
		<?php 
	}

} // phishnet_upcoming_Widget

// register widget
add_action( 'widgets_init', create_function( '', 'register_widget( "phishnet_upcoming_Widget" );' ) );